/* TeXFoGcontroller */

#import <Cocoa/Cocoa.h>

#define	kSuperscript		@"^{}"
#define	kSubscript		@"_{}"
#define	kFraction		@"\\frac{}{}" // la prima \ serve per printare la seconda, se no viene interpretata come \f
#define	kRoot			@"\\sqrt{}"
#define	kRootN			@"\\sqrt[]{}"
#define	kLowEllipsis		@"\\ldots"
#define	kCenteredEllipsis	@"\\cdots"
#define	kVerticalDots		@"\\vdots"
#define	kDiagonalDots		@"\\ddots"

// lettere greghe
#define	kalpha			@"\\alpha"
#define	kbeta			@"\\beta"
#define	kgamma			@"\\gamma"
#define	kdelta			@"\\delta"
#define	kepsilon		@"\\epsilon"
#define	kvarepsilon		@"\\varepsilon"
#define	kzeta			@"\\zeta"
#define	keta			@"\\eta"
#define	ktheta			@"\\theta"
#define	kvartheta		@"\\vartheta"
#define	kiota			@"\\iota"
#define	kkappa			@"\\kappa"
#define	klambda			@"\\lambda"
#define	kmu			@"\\mu"
#define	knu			@"\\nu"
#define	kxi			@"\\xi"
#define	ko			@"o"
#define	kpi			@"\\pi"
#define	kvarpi			@"\\varpi"
#define	krho			@"\\rho"
#define	kvarrho			@"\\varrho"
#define	ksigma			@"\\sigma"
#define	kvarsigma		@"\\varsigma"
#define	ktau			@"\\tau"
#define	kupsilon		@"\\upsilon"
#define	kphi			@"\\phi"
#define	kvarphi			@"\\varphi"
#define	kchi			@"\\chi"
#define	kpsi			@"\\psi"
#define	komega			@"\\omega"
#define	kGamma			@"\\Gamma"
#define	kDelta			@"\\Delta"
#define	kTheta			@"\\Theta"
#define	kLambda			@"\\Lambda"
#define	kXi			@"\\Xi"
#define	kPi			@"\\Pi"
#define	kSigma			@"\\Sigma"
#define	kUpsilon		@"\\Upsilon"
#define	kPhi			@"\\Phi"
#define	kPsi			@"\\Psi"
#define	kOmega			@"\\Omega"
#define	kCalligraphic		@"\\mathcal{}"

// binary operation symbols
#define kpm			@"\\pm"
#define kmp			@"\\mp"
#define	ktimes			@"\\times"
#define kdiv			@"\\div"
#define	kast			@"\\ast"
#define	kstar			@"\\star"
#define	kcirc			@"\\circ"
#define	kbullet			@"\\bullet"
#define	kcdot			@"\\cdot"
#define	kcap			@"\\cap"
#define	kcup			@"\\cup"
#define	kuplus			@"\\uplus"
#define	ksqcap			@"\\sqcap"
#define	ksqcup			@"\\sqcup"
#define	kvee			@"\\vee"
#define	kwedge			@"\\wedge"
#define	ksetminus		@"\\setminus"
#define	kwr			@"\\wr"
#define	kdiamond		@"\\diamond"
#define	kbigtriangleup		@"\\bigtriangleup"
#define	kbigtriangledown	@"\\bigtriangledown"
#define	ktriangleleft		@"\\triangleleft"
#define	ktriangleright		@"\\triangleright"
#define	klhd			@"\\lhd"
#define	krhd			@"\\rhd"
#define	kunlhd			@"\\unlhd"
#define	kunrhd			@"\\unrhd"
#define	koplus			@"\\oplus"
#define	kominus			@"\\ominus"
#define	kotimes			@"\\otimes"
#define	koslash			@"\\oslash"
#define	kodot			@"\\odot"
#define	kbigcirc		@"\\bigcirc"
#define	kdagger			@"\\dagger"
#define	kddagger		@"\\ddagger"
#define	kamalg			@"\\amalg"
#define	kNegate			@"\\not"

// parentesi
#define	kLeftParenthesis	@"\\left("
#define	kRightParenthesis	@"\\right)"
#define	kCoupleParenthesis	@"\\left(\\right)"
#define	kLeftBracket		@"\\left["
#define	kRightBracket		@"\\right]"
#define	kCoupleBracket		@"\\left[\\right]"
#define	kLeftBrace		@"\\left\\{"
#define	kRightBrace		@"\\right\\}"
#define	kCoupleBrace		@"\\left\\{\\right\\}"
#define	kLeftAngle		@"\\langle"
#define	kRightAngle		@"\\rangle"
#define	kCoupleAngle		@"\\langle\\rangle"
#define	klfloor			@"\\lfloor"
#define	klceil			@"\\lceil"
#define	krfloor			@"\\rfloor"
#define	krceil			@"\\rceil"
#define	kleftvbar		@"\\left|"
#define	krightvbar		@"\\right|"
#define	kcouplevbar		@"\\left|\\right|"

// relation symbols
#define	kleq			@"\\leq"
#define	kprec			@"\\prec"
#define	kpreceq			@"\\preceq"
#define	kll			@"\\ll"
#define	ksubset			@"\\subset"
#define	ksubseteq		@"\\subseteq"
#define	ksqsubset		@"\\sqsubset"
#define	ksqsubseteq		@"\\sqsubseteq"
#define	kin			@"\\in"
#define	kvdash			@"\\vdash"
#define	kgeq			@"\\geq"
#define	ksucc			@"\\succ"
#define	ksucceq			@"\\succeq"
#define	kgg			@"\\gg"
#define	ksupset			@"\\supset"
#define	ksupseteq		@"\\supseteq"
#define	ksqsupset		@"\\sqsupset"
#define	ksqsupseteq		@"\\sqsupseteq"
#define	kni			@"\\ni"
#define	kdashv			@"\\dashv"
#define	kequiv			@"\\equiv"
#define	ksim			@"\\sim"
#define	ksimeq			@"\\simeq"
#define	kasymp			@"\\asymp"
#define	kapprox			@"\\approx"
#define	kcong			@"\\cong"
#define	kneq			@"\\neq"
#define	kdoteq			@"\\doteq"
#define	kpropto			@"\\propto"
#define	kmodels			@"\\models"
#define	kperp			@"\\perp"
#define	kmid			@"\\mid"
#define	kparallel		@"\\parallel"
#define	kbowtie			@"\\bowtie"
#define	kJoin			@"\\Join"
#define	ksmile			@"\\smile"
#define	kfrown			@"\\frown"

// variable size symbols in common
#define	ksum			@"\\sum"
#define	kprod			@"\\prod"
#define	kcoprod			@"\\coprod"
#define	kint			@"\\int"
#define	koint			@"\\oint"
#define	kbigcap			@"\\bigcap"
#define	kbigcup			@"\\bigcup"
#define	kbigsqcup		@"\\bigsqcup"
#define	kbigvee			@"\\bigvee"
#define	kbigwedge		@"\\bigwedge"
#define	kbigodot		@"\\bigodot"
#define	kbigotimes		@"\\bigotimes"
#define	kbigoplus		@"\\bigoplus"
#define	kbiguplus		@"\\biguplus"

// arrows
#define	kleftarrow		@"\\leftarrow"
#define	kLeftarrow		@"\\Leftarrow"
#define	krightarrow		@"\\rightarrow"
#define	kRightarrow		@"\\Rightarrow"
#define	kleftrightarrow		@"\\leftrightarrow"
#define	kLeftrightarrow		@"\\Leftrightarrow"
#define	kmapsto			@"\\mapsto"
#define	khookleftarrow		@"\\hookleftarrow"
#define	kleftharpoonup		@"\\leftharpoonup"
#define	kleftharpoondown	@"\\leftharpoondown"
#define	krightleftharpoons	@"\\rightleftharpoons"
#define	klongleftarrow		@"\\longleftarrow"
#define	kLongleftarrow		@"\\Longleftarrow"
#define	klongrightarrow		@"\\longrightarrow"
#define	kLongrightarrow		@"\\Longrightarrow"
#define	klongleftrightarrow	@"\\longleftrightarrow"
#define	kLongleftrightarrow	@"\\Longleftrightarrow"
#define	klongmapsto		@"\\longmapsto"
#define	khookrightarrow		@"\\hookrightarrow"
#define	krightharpoonup		@"\\rightharpoonup"
#define	krightharpoondown	@"\\rightharpoondown"
#define	kleadsto		@"\\leadsto"
#define	kuparrow		@"\\uparrow"
#define	kUparrow		@"\\Uparrow"
#define	kdownarrow		@"\\downarrow"
#define	kDownarrow		@"\\Downarrow"
#define	kupdownarrow		@"\\updownarrow"
#define	kUpdownarrow		@"\\Updownarrow"
#define	knearrow		@"\\nearrow"
#define	ksearrow		@"\\searrow"
#define	kswarrow		@"\\swarrow"
#define	knwarrow		@"\\nwarrow"

// miscellanea
#define	kaleph			@"\\aleph"
#define	khbar			@"\\hbar"
#define	kimath			@"\\imath"
#define	kjmath			@"\\jmath"
#define	kell			@"\\ell"
#define	kwp			@"\\wp"
#define	kRe			@"\\Re"
#define	kIm			@"\\Im"
#define	kmho			@"\\mho"
#define	kprime			@"\\prime"
#define	kemptyset		@"\\emptyset"
#define	knabla			@"\\nabla"
#define	ksurd			@"\\surd"
#define	ktop			@"\\top"
#define	kbot			@"\\bot"
#define	kdoubleVertBar		@"\\|"
#define	kangle			@"\\angle"
#define	kforall			@"\\forall"
#define	kexists			@"\\exists"
#define	kneg			@"\\neg"
#define	kflat			@"\\flat"
#define	knatural		@"\\natural"
#define	ksharp			@"\\sharp"
#define	kbackslash		@"\\backslash"
#define	kpartial		@"\\partial"
#define	kinfty			@"\\infty"
#define	kBox			@"\\Box"
#define	kDiamond		@"\\Diamond"
#define	ktriangle		@"\\triangle"
#define	kclubsuit		@"\\clubsuit"
#define	kdiamondsuit		@"\\diamondsuit"
#define	kheartsuit		@"\\heartsuit"
#define	kspadesuit		@"\\spadesuit"

// functions
#define	karccos			@"\\arccos"
#define	karcsin			@"\\arcsin"
#define	karctan			@"\\arctan"
#define	karg			@"\\arg"
#define	kcos			@"\\cos"
#define	kcosh			@"\\cosh"
#define	kcot			@"\\cot"
#define	kcoth			@"\\coth"
#define	kcsc			@"\\csc"
#define	kdeg			@"\\deg"
#define	kdet			@"\\det"
#define	kdim			@"\\dim"
#define	kexp			@"\\exp"
#define	kgcd			@"\\gcd"
#define	khom			@"\\hom"
#define	kinf			@"\\inf"
#define	kker			@"\\ker"
#define	klg			@"\\lg"
#define	klim			@"\\lim"
#define	kliminf			@"\\liminf"
#define	klimsup			@"\\limsup"
#define	kln			@"\\ln"
#define	klog			@"\\log"
#define	kmax			@"\\max"
#define	kmin			@"\\min"
#define	kPr			@"\\Pr"
#define	ksec			@"\\sec"
#define	ksin			@"\\sin"
#define	ksinh			@"\\sinh"
#define	ksup			@"\\sup"
#define	ktan			@"\\tan"
#define	ktanh			@"\\tanh"
#define	kbmod			@"\\bmod"
#define	kpmod			@"\\pmod{}"

// letters and accents
#define	koe			@"\\oe"
#define	kOE			@"\\OE"
#define	kae			@"\\ae"
#define	kAE			@"\\AE"
#define	kaa			@"\\aa"
#define	kAA			@"\\AA"
#define	kobar			@"\\o"
#define	kO			@"\\O"
#define	kl			@"\\l"
#define	kL			@"\\L"
#define	kss			@"\\ss"
#define	kQuestionMark		@"?'"
#define	kExclamationMark	@"!'"
#define	khat			@"\\hat{}"
#define	kcheck			@"\\check{}"
#define	kbreve			@"\\breve{}"
#define	kacute			@"\\acute{}"
#define	kgrave			@"\\grave{}"
#define	ktilde			@"\\tilde{}"
#define	kbar			@"\\bar{}"
#define	kvec			@"\\vec{}"
#define	kdot			@"\\dot{}"
#define	kddot			@"\\ddot{}"

// formatting
#define	koverline		@"\\overline{}"
#define	kunderline		@"\\underline{}"
#define	koverbrace		@"\\overbrace{}"
#define	kunderbrace		@"\\underbrace{}"
#define	kthinspace		@"\\,"
#define	knegthinspace		@"\\!"
#define	kmediumspace		@"\\:"
#define	kthickspace		@"\\;"
#define	kwordspace		@"\\ "
#define	kstacking		@"\\stackrel{}{}"

@interface TeXFoGcontroller : NSWindowController
{
    IBOutlet	NSTextView	*editableText;
    IBOutlet	NSButton	*superButton;
    IBOutlet	NSButton	*subButton;
    IBOutlet	NSButton	*fractionButton;
    IBOutlet	NSButton	*rootButton;
    IBOutlet	NSButton	*rootNButton;
    IBOutlet	NSButton	*lowEllipsis;
    IBOutlet	NSButton	*centeredEllipsis;
    IBOutlet	NSButton	*verticalDots;
    IBOutlet	NSButton	*diagonalDots;
	IBOutlet	NSButton	*pasteIntoEditorButton;
	IBOutlet	NSButton	*typesetButton;
    
    NSMutableString		*version;
    BOOL			moveInsertionPoint;
    BOOL			useModifierKey;
    int				whatModifierKey;
	NSString		*editor;
	NSString		*latexEnginePath;
	NSString		*ghostscriptEnginePath;
}

- (void)synchronizeData;

- (IBAction) doSuper:(id)sender;
- (IBAction) doSub:(id)sender;
- (IBAction) doFraction:(id)sender;
- (IBAction) doRoot:(id)sender;
- (IBAction) doRootN:(id)sender;
- (IBAction) doLowEllipsis:(id)sender;
- (IBAction) doCenteredEllipsis:(id)sender;
- (IBAction) doVerticalDots:(id)sender;
- (IBAction) doDiagonalDots:(id)sender;
- (IBAction) doalpha:(id)sender;
- (IBAction) dobeta:(id)sender;
- (IBAction) dogamma:(id)sender;
- (IBAction) dodelta:(id)sender;
- (IBAction) doepsilon:(id)sender;
- (IBAction) dovarepsilon:(id)sender;
- (IBAction) dozeta:(id)sender;
- (IBAction) doeta:(id)sender;
- (IBAction) dotheta:(id)sender;
- (IBAction) dovartheta:(id)sender;
- (IBAction) doiota:(id)sender;
- (IBAction) dokappa:(id)sender;
- (IBAction) dolambda:(id)sender;
- (IBAction) domu:(id)sender;
- (IBAction) donu:(id)sender;
- (IBAction) doxi:(id)sender;
- (IBAction) doo:(id)sender;
- (IBAction) dopi:(id)sender;
- (IBAction) dovarpi:(id)sender;
- (IBAction) dorho:(id)sender;
- (IBAction) dovarrho:(id)sender;
- (IBAction) dosigma:(id)sender;
- (IBAction) dovarsigma:(id)sender;
- (IBAction) dotau:(id)sender;
- (IBAction) doupsilon:(id)sender;
- (IBAction) dophi:(id)sender;
- (IBAction) dovarphi:(id)sender;
- (IBAction) dochi:(id)sender;
- (IBAction) dopsi:(id)sender;
- (IBAction) doomega:(id)sender;
- (IBAction) doGamma:(id)sender;
- (IBAction) doDelta:(id)sender;
- (IBAction) doTheta:(id)sender;
- (IBAction) doLambda:(id)sender;
- (IBAction) doXi:(id)sender;
- (IBAction) doPi:(id)sender;
- (IBAction) doSigma:(id)sender;
- (IBAction) doUpsilon:(id)sender;
- (IBAction) doPhi:(id)sender;
- (IBAction) doPsi:(id)sender;
- (IBAction) doOmega:(id)sender;
- (IBAction) doCalligraphic:(id)sender;
- (IBAction) dopm:(id)sender;
- (IBAction) domp:(id)sender;
- (IBAction) dotimes:(id)sender;
- (IBAction) dodiv:(id)sender;
- (IBAction) doast:(id)sender;
- (IBAction) dostar:(id)sender;
- (IBAction) docirc:(id)sender;
- (IBAction) dobullet:(id)sender;
- (IBAction) docdot:(id)sender;
- (IBAction) docap:(id)sender;
- (IBAction) docup:(id)sender;
- (IBAction) douplus:(id)sender;
- (IBAction) dosqcap:(id)sender;
- (IBAction) dosqcup:(id)sender;
- (IBAction) dovee:(id)sender;
- (IBAction) dowedge:(id)sender;
- (IBAction) dosetminus:(id)sender;
- (IBAction) dowr:(id)sender;
- (IBAction) dodiamond:(id)sender;
- (IBAction) dobigtriangleup:(id)sender;
- (IBAction) dobigtriangledown:(id)sender;
- (IBAction) dotriangleleft:(id)sender;
- (IBAction) dotriangleright:(id)sender;
- (IBAction) dolhd:(id)sender;
- (IBAction) dorhd:(id)sender;
- (IBAction) dounlhd:(id)sender;
- (IBAction) dounrhd:(id)sender;
- (IBAction) dooplus:(id)sender;
- (IBAction) doominus:(id)sender;
- (IBAction) dootimes:(id)sender;
- (IBAction) dooslash:(id)sender;
- (IBAction) doodot:(id)sender;
- (IBAction) dobigcirc:(id)sender;
- (IBAction) dodagger:(id)sender;
- (IBAction) doddagger:(id)sender;
- (IBAction) doamalg:(id)sender;
- (IBAction) doNegate:(id)sender;
- (IBAction) doLeftParenthesis:(id)sender;
- (IBAction) doRightParenthesis:(id)sender;
- (IBAction) doCoupleParenthesis:(id)sender;
- (IBAction) doLeftBracket:(id)sender;
- (IBAction) doRightBracket:(id)sender;
- (IBAction) doCoupleBracket:(id)sender;
- (IBAction) doLeftBrace:(id)sender;
- (IBAction) doRightBrace:(id)sender;
- (IBAction) doCoupleBrace:(id)sender;
- (IBAction) doLeftAngle:(id)sender;
- (IBAction) doRightAngle:(id)sender;
- (IBAction) doCoupleAngle:(id)sender;
- (IBAction) dolfloor:(id)sender;
- (IBAction) dolceil:(id)sender;
- (IBAction) dorfloor:(id)sender;
- (IBAction) dorceil:(id)sender;
- (IBAction) doleftvbar:(id)sender;
- (IBAction) dorightvbar:(id)sender;
- (IBAction) docouplevbar:(id)sender;
- (IBAction) doleq:(id)sender;
- (IBAction) doprec:(id)sender;
- (IBAction) dopreceq:(id)sender;
- (IBAction) doll:(id)sender;
- (IBAction) dosubset:(id)sender;
- (IBAction) dosubseteq:(id)sender;
- (IBAction) dosqsubset:(id)sender;
- (IBAction) dosqsubseteq:(id)sender;
- (IBAction) doin:(id)sender;
- (IBAction) dovdash:(id)sender;
- (IBAction) dogeq:(id)sender;
- (IBAction) dosucc:(id)sender;
- (IBAction) dosucceq:(id)sender;
- (IBAction) dogg:(id)sender;
- (IBAction) dosupset:(id)sender;
- (IBAction) dosupseteq:(id)sender;
- (IBAction) dosqsupset:(id)sender;
- (IBAction) dosqsupseteq:(id)sender;
- (IBAction) doni:(id)sender;
- (IBAction) dodashv:(id)sender;
- (IBAction) doequiv:(id)sender;
- (IBAction) dosim:(id)sender;
- (IBAction) dosimeq:(id)sender;
- (IBAction) doasymp:(id)sender;
- (IBAction) doapprox:(id)sender;
- (IBAction) docong:(id)sender;
- (IBAction) doneq:(id)sender;
- (IBAction) dodoteq:(id)sender;
- (IBAction) dopropto:(id)sender;
- (IBAction) domodels:(id)sender;
- (IBAction) doperp:(id)sender;
- (IBAction) domid:(id)sender;
- (IBAction) doparallel:(id)sender;
- (IBAction) dobowtie:(id)sender;
- (IBAction) doJoin:(id)sender;
- (IBAction) dosmile:(id)sender;
- (IBAction) dofrown:(id)sender;
- (IBAction) dosum:(id)sender;
- (IBAction) doprod:(id)sender;
- (IBAction) docoprod:(id)sender;
- (IBAction) doint:(id)sender;
- (IBAction) dooint:(id)sender;
- (IBAction) dobigcap:(id)sender;
- (IBAction) dobigcup:(id)sender;
- (IBAction) dobigsqcup:(id)sender;
- (IBAction) dobigvee:(id)sender;
- (IBAction) dobigwedge:(id)sender;
- (IBAction) dobigodot:(id)sender;
- (IBAction) dobigotimes:(id)sender;
- (IBAction) dobigoplus:(id)sender;
- (IBAction) dobiguplus:(id)sender;
- (IBAction) doleftarrow:(id)sender;
- (IBAction) doLeftarrow:(id)sender;
- (IBAction) dorightarrow:(id)sender;
- (IBAction) doRightarrow:(id)sender;
- (IBAction) doleftrightarrow:(id)sender;
- (IBAction) doLeftrightarrow:(id)sender;
- (IBAction) domapsto:(id)sender;
- (IBAction) dohookleftarrow:(id)sender;
- (IBAction) doleftharpoonup:(id)sender;
- (IBAction) doleftharpoondown:(id)sender;
- (IBAction) dorightleftharpoons:(id)sender;
- (IBAction) dolongleftarrow:(id)sender;
- (IBAction) doLongleftarrow:(id)sender;
- (IBAction) dolongrightarrow:(id)sender;
- (IBAction) doLongrightarrow:(id)sender;
- (IBAction) dolongleftrightarrow:(id)sender;
- (IBAction) doLongleftrightarrow:(id)sender;
- (IBAction) dolongmapsto:(id)sender;
- (IBAction) dohookrightarrow:(id)sender;
- (IBAction) dorightharpoonup:(id)sender;
- (IBAction) dorightharpoondown:(id)sender;
- (IBAction) doleadsto:(id)sender;
- (IBAction) douparrow:(id)sender;
- (IBAction) doUparrow:(id)sender;
- (IBAction) dodownarrow:(id)sender;
- (IBAction) doDownarrow:(id)sender;
- (IBAction) doupdownarrow:(id)sender;
- (IBAction) doUpdownarrow:(id)sender;
- (IBAction) donearrow:(id)sender;
- (IBAction) dosearrow:(id)sender;
- (IBAction) doswarrow:(id)sender;
- (IBAction) donwarrow:(id)sender;
- (IBAction) doaleph:(id)sender;
- (IBAction) dohbar:(id)sender;
- (IBAction) doimath:(id)sender;
- (IBAction) dojmath:(id)sender;
- (IBAction) doell:(id)sender;
- (IBAction) dowp:(id)sender;
- (IBAction) doRe:(id)sender;
- (IBAction) doIm:(id)sender;
- (IBAction) domho:(id)sender;
- (IBAction) doprime:(id)sender;
- (IBAction) doemptyset:(id)sender;
- (IBAction) donabla:(id)sender;
- (IBAction) dosurd:(id)sender;
- (IBAction) dotop:(id)sender;
- (IBAction) dobot:(id)sender;
- (IBAction) dodoubleVertBar:(id)sender;
- (IBAction) doangle:(id)sender;
- (IBAction) doforall:(id)sender;
- (IBAction) doexists:(id)sender;
- (IBAction) doneg:(id)sender;
- (IBAction) doflat:(id)sender;
- (IBAction) donatural:(id)sender;
- (IBAction) dosharp:(id)sender;
- (IBAction) dobackslash:(id)sender;
- (IBAction) dopartial:(id)sender;
- (IBAction) doinfty:(id)sender;
- (IBAction) doBox:(id)sender;
- (IBAction) doDiamond:(id)sender;
- (IBAction) dotriangle:(id)sender;
- (IBAction) doclubsuit:(id)sender;
- (IBAction) dodiamondsuit:(id)sender;
- (IBAction) doheartsuit:(id)sender;
- (IBAction) dospadesuit:(id)sender;
- (IBAction) doarccos:(id)sender;
- (IBAction) doarcsin:(id)sender;
- (IBAction) doarctan:(id)sender;
- (IBAction) doarg:(id)sender;
- (IBAction) docos:(id)sender;
- (IBAction) docosh:(id)sender;
- (IBAction) docot:(id)sender;
- (IBAction) docoth:(id)sender;
- (IBAction) docsc:(id)sender;
- (IBAction) dodeg:(id)sender;
- (IBAction) dodet:(id)sender;
- (IBAction) dodim:(id)sender;
- (IBAction) doexp:(id)sender;
- (IBAction) dogcd:(id)sender;
- (IBAction) dohom:(id)sender;
- (IBAction) doinf:(id)sender;
- (IBAction) doker:(id)sender;
- (IBAction) dolg:(id)sender;
- (IBAction) dolim:(id)sender;
- (IBAction) doliminf:(id)sender;
- (IBAction) dolimsup:(id)sender;
- (IBAction) doln:(id)sender;
- (IBAction) dolog:(id)sender;
- (IBAction) domax:(id)sender;
- (IBAction) domin:(id)sender;
- (IBAction) doPr:(id)sender;
- (IBAction) dosec:(id)sender;
- (IBAction) dosin:(id)sender;
- (IBAction) dosinh:(id)sender;
- (IBAction) dosup:(id)sender;
- (IBAction) dotan:(id)sender;
- (IBAction) dotanh:(id)sender;
- (IBAction) dobmod:(id)sender;
- (IBAction) dopmod:(id)sender;
- (IBAction) dooe:(id)sender;
- (IBAction) doOE:(id)sender;
- (IBAction) doae:(id)sender;
- (IBAction) doAE:(id)sender;
- (IBAction) doaa:(id)sender;
- (IBAction) doAA:(id)sender;
- (IBAction) doobar:(id)sender;
- (IBAction) doO:(id)sender;
- (IBAction) dol:(id)sender;
- (IBAction) doL:(id)sender;
- (IBAction) doss:(id)sender;
- (IBAction) doQuestionMark:(id)sender;
- (IBAction) doExclamationMark:(id)sender;
- (IBAction) dohat:(id)sender;
- (IBAction) docheck:(id)sender;
- (IBAction) dobreve:(id)sender;
- (IBAction) doacute:(id)sender;
- (IBAction) dograve:(id)sender;
- (IBAction) dotilde:(id)sender;
- (IBAction) dobar:(id)sender;
- (IBAction) dovec:(id)sender;
- (IBAction) dodot:(id)sender;
- (IBAction) doddot:(id)sender;
- (IBAction) dooverline:(id)sender;
- (IBAction) dounderline:(id)sender;
- (IBAction) dooverbrace:(id)sender;
- (IBAction) dounderbrace:(id)sender;
- (IBAction) dothinspace:(id)sender;
- (IBAction) donegthinspace:(id)sender;
- (IBAction) domediumspace:(id)sender;
- (IBAction) dothickspace:(id)sender;
- (IBAction) dowordspace:(id)sender;
- (IBAction) dostacking:(id)sender;

- (IBAction) pasteIntoEditor:(id)sender;
- (IBAction) typeset:(id)sender;

- (void)readDefaults;
- (void)setFirstTimeDefaults;
- (void)moveInsertionPointBy:(int)places;

@end
